<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>propclass/mechsteer.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">propclass/mechsteer.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2005 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment">  </span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment">  </span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment">  </span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_PF_MECHANICS_STEER__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_PF_MECHANICS_STEER__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cstypes_8h.html">cstypes.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;propclass/mechcommon.h&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="keyword">class </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>;
<a name="l00029"></a>00029 <span class="keyword">struct </span><a class="code" href="structiPcMechanicsObject.html" title="A dynamic body.">iPcMechanicsObject</a>;
<a name="l00030"></a>00030 
<a name="l00035"></a><a class="code" href="structiPcMechanicsSteering.html">00035</a> <span class="keyword">struct </span><a class="code" href="structiPcMechanicsSteering.html" title="Property class representing a steering mechanism that affects forces on the attached object...">iPcMechanicsSteering</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037   SCF_INTERFACE (<a class="code" href="structiPcMechanicsSteering.html" title="Property class representing a steering mechanism that affects forces on the attached object...">iPcMechanicsSteering</a>, 0, 0, 1);
<a name="l00038"></a>00038 
<a name="l00042"></a>00042   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMechanicsSteering.html#a6072c8f4e8f66aa7cf96d400c470471f" title="Set this thruster&#39;s identifier.">SetID</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* <span class="keywordtype">id</span>) = 0;
<a name="l00043"></a>00043 
<a name="l00047"></a>00047   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiPcMechanicsSteering.html#a8721528b0854f77a9eb3aab6f0803795" title="Get this thruster&#39;s identifier.">GetID</a> () = 0;
<a name="l00048"></a>00048 
<a name="l00052"></a>00052   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMechanicsSteering.html#a4c80ff461f6ad7cf4ac414f017eb4149" title="Set the mechanics object to affect.">SetMechanicsObject</a> (<a class="code" href="structiPcMechanicsObject.html" title="A dynamic body.">iPcMechanicsObject</a>* mechsys) = 0;
<a name="l00053"></a>00053 
<a name="l00057"></a>00057   <span class="keyword">virtual</span> <a class="code" href="structiPcMechanicsObject.html" title="A dynamic body.">iPcMechanicsObject</a>* <a class="code" href="structiPcMechanicsSteering.html#a77ade08a0e0777a0701947d123927c1d" title="Get the associated mechanics object.">GetMechanicsObject</a> () = 0;
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00061"></a>00061   <span class="comment">//MechanicsSteering properties</span>
<a name="l00062"></a>00062 
<a name="l00066"></a>00066   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMechanicsSteering.html#a777dc92538a7fab2fd08bee1b57ea04e" title="Set the position of this steering mechanism.">SetPosition</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> position) = 0;
<a name="l00067"></a>00067 
<a name="l00071"></a>00071   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> <a class="code" href="structiPcMechanicsSteering.html#a08e00cee4549bf76c16f76980fa3b026" title="Get the position of this steering mechanism.">GetPosition</a> () = 0;
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 
<a name="l00077"></a>00077   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMechanicsSteering.html#ad78df612953d3c6120f1ea7fde397ab2" title="Set the axis of rotation for this steering mechanism.">SetAxis</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> axis) = 0;
<a name="l00078"></a>00078 
<a name="l00082"></a>00082   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> <a class="code" href="structiPcMechanicsSteering.html#ab472530885b6f2bcc309ed32a317c52b" title="Get the axis of rotation for this steering mechanism.">GetAxis</a> () = 0;
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00086"></a>00086   <span class="comment">//Angle</span>
<a name="l00087"></a>00087 
<a name="l00091"></a>00091   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMechanicsSteering.html#add56d73e59d2671019d772d207583c2e" title="Set the angle of the steering mechanism.">SetAngle</a> (percentage angle) = 0;
<a name="l00092"></a>00092 
<a name="l00096"></a>00096   <span class="keyword">virtual</span> percentage <a class="code" href="structiPcMechanicsSteering.html#a494f09283c28ea7217313bc81f530141" title="Get the angle of the steering mechanism.">GetAngle</a> () = 0;
<a name="l00097"></a>00097 
<a name="l00101"></a>00101   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMechanicsSteering.html#ad012825c7caf6798dcb8e728a4a0e403" title="Set the maximum angle of the steering mechanism.">SetMaxAngle</a> (<span class="keywordtype">float</span> maxangle) = 0;
<a name="l00102"></a>00102 
<a name="l00106"></a>00106   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiPcMechanicsSteering.html#ac5212dd4531172eaf7bafd4613f52b94" title="Get the maximum angle of the steering mechanism.">GetMaxAngle</a> () = 0;
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00110"></a>00110   <span class="comment">//Turning</span>
<a name="l00111"></a>00111 
<a name="l00116"></a>00116   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMechanicsSteering.html#abd95beddadfe6c7da6baf6229867875b" title="Turn the steering mechanism.">Turn</a> (percentage speed = 0.0) = 0;
<a name="l00117"></a>00117 
<a name="l00121"></a>00121   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMechanicsSteering.html#a6634ba7201499a99364e666a4ac07465" title="Turn the steering mechanism to the given angle percentage.">TurnTo</a> (percentage angle, percentage speed = 1.0) = 0;
<a name="l00122"></a>00122 
<a name="l00126"></a>00126   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMechanicsSteering.html#a314479b4f9a6c9176d77dfe0b54ce291" title="Set the maximum turning speed of this steering mechanism.">SetMaxTurnSpeed</a> (<span class="keywordtype">float</span> maxspeed) = 0;
<a name="l00127"></a>00127 
<a name="l00131"></a>00131   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiPcMechanicsSteering.html#ae2049d17abad9d3214d777fe492e2118" title="Get the maximum turning speed this steering mechanism.">GetMaxTurnSpeed</a> () = 0;
<a name="l00132"></a>00132 };
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 <span class="preprocessor">#endif //__CEL_PF_MECHANICS_STEER__</span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
